mod Ex07 logic: 'cl'

incl Mtex

incl Mtexrc

incl Mtexxpr

incl Maux

incl Mxprf

loc rem 
  \para \bf  6. CVICENIE Z PREDMETU 1-INF-450 LOGIKA PRE INFORMATIKOV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.19 
  \para* \it  Datum:  \end utorok 4.11.2008 
  \para* \it  WWW:  \end 
  http://ii.fmph.uniba.sk/cl/view.php/courses/1-INF-450-lpi/0809zs/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane obecne rekurzivnym 
  fukciam (univerzalna funkcia pre p.r. funkcie). Zadanie sa sklada z tychto 
  suborov: z tychto suborov: 
  \items 
   \item \para Subor(y) \it  mtex*.cl  \end obsahuje makra pre CL-TeX. 
   \item \para Subor(y) \it  maux*.cl  \end obsahuje definicie niektorych 
         funkcii a predikatov. 
   \item \para Subor \it  mxprf.cl  \end obsahuje aritmetizaciu p.r. funkcnych 
         symbolov. 
   \item \para Subor(y) \it  ex*.cl  \end obsahuje ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

loc rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Pocet bodov za ulohy v tomto subore: 4 
   \item \para Pocet bodov za premiove ulohy v tomto subore: 0 
  \end
  \para Odovzdat do 10.11.2008 (pondelok) do 12:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end Downloadable lecture notes available through the 
         web page of the course. 
   \item \para \it  [2]  \end J. Komara and P. J. Voda. Lecture Notes in Theory 
         of Computability. 2001. 
   \item \para \it  [3]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  [CL] Remark.  \end The module \it  Msyntax  \end in the file \it  
  msyntax.cl  \end contains the syntax of the system CL. 

rem 
  \para \bf  Remark.  \end Clausal language is allowed. 

rem 
  \para \bf  Remark.  \end The abbreviation \it  p.r.  \end stands for \it  
  primitive recursive  \end. 

rem 
  \para \bf  Chapter. General Recursive Functions.  \end See [1]. 

rem 
  \para \bf  Section. Beyond Primitive Recursion: Universal Function for 
  Primitive Recursive Functions.  \end 

rem 
  \para \bf  Arithmetization of primitive recursive function symbols.  \end See 
  also the module \it  Mxprf  \end. 

rem 
  \para \bf  Exercise. \it  (1 point)  \end  \end Define the interpreter of p.r. 
  function symbols. 

fun/2 Interpreter 'Tex_f2_xpr_interpreter'
  Interpreter(e,x) = Foo

rem 
  \para \bf  Subsection. Primitive Recursive Indices.  \end 

rem 
  \para \bf  Primitive recursive indices.  \end See also the binary predicate 
  \ft Prf(n,e) \end holding of well-formed p.r. indices defined in the module 
  \it  Mxprf  \end. 

rem 
  \para \bf  Exercise.  \end \header* fun/0 Xc1_1 'Tex_f0_xpr_xc1_1' \end Find a 
  well-formed p.r. index of the unary constant function \ft C1(x) = 1 \end, i.e. 
  find the number \ft Xc1_1 \end such that 
  \eq* 
    Prf(1,Xc1_1)
  \end
  \eq* 
    Interpreter(Xc1_1,x) = 1
  \end

fun/0 Xc1_1 'Tex_f0_xpr_xc1_1'
  Xc1_1 = Foo

thm Spec_xc1
  Interpreter(Xc1_1,x) = 1

rem 
  \para \bf  Exercise.  \end \header* fun/0 Xc1_2 'Tex_f0_xpr_xc1_2' \end Find a 
  well-formed p.r. index of the unary constant function \ft C2(x) = 2 \end, i.e. 
  find the number \ft Xc1_2 \end such that 
  \eq* 
    Prf(1,Xc1_2)
  \end
  \eq* 
    Interpreter(Xc1_2,x) = 2
  \end

fun/0 Xc1_2 'Tex_f0_xpr_xc1_2'
  Xc1_2 = Foo

thm Spec_xc1_2
  Interpreter(Xc1_2,x) = 2

rem 
  \para \bf  Exercise.  \end \header* fun/0 Xc1_3 'Tex_f0_xpr_xc1_3' \end Find a 
  well-formed p.r. index of the unary constant function \ft C3(x) = 3 \end, i.e. 
  find the number \ft Xc1_3 \end such that 
  \eq* 
    Prf(1,Xc1_3)
  \end
  \eq* 
    Interpreter(Xc1_3,x) = 3
  \end

fun/0 Xc1_3 'Tex_f0_xpr_xc1_3'
  Xc1_3 = Foo

thm Spec_xc1_3
  Interpreter(Xc1_3,x) = 3

rem 
  \para \bf  Exercise. \it  (1 point)  \end  \end 
  \header* fun/0 Xplus 'Tex_f0_xpr_xplus' \end Find a well-formed p.r. index of 
  the addition function \ft x+y \end, i.e. find the number \ft Xplus \end such 
  that 
  \eq* 
    Prf(2,Xplus)
  \end
  \eq* 
    Interpreter(Xplus,x,y) = x+y
  \end

fun/0 Xplus 'Tex_f0_xpr_xplus'
  Xplus = Foo

thm Spec_xplus
  Interpreter(Xplus,x,y) = x+y

rem 
  \para \bf  Exercise.  \end \header* fun/0 Xtimes 'Tex_f0_xpr_xtimes' \end Find 
  a well-formed p.r. index of the multiplication function \ft x*y \end, i.e. 
  find the number \ft Xtimes \end such that 
  \eq* 
    Prf(2,Xtimes)
  \end
  \eq* 
    Interpreter(Xtimes,x,y) = x*y
  \end

fun/0 Xtimes 'Tex_f0_xpr_xtimes'
  Xtimes = Foo

thm Spec_xtimes
  Interpreter(Xtimes,x,y) = x*y

rem 
  \para \bf  Exercise. \it  (1 point)  \end  \end 
  \header* fun/0 Xexp 'Tex_f0_xpr_xexp' \end Find a well-formed p.r. index of 
  the exponentiation function \ft Exp(x,y) \end, i.e. find the number 
  \ft Xexp \end such that 
  \eq* 
    Prf(2,Xexp)
  \end
  \eq* 
    Interpreter(Xexp,x,y) = Exp(x,y)
  \end

fun/0 Xexp 'Tex_f0_xpr_xexp'
  Xexp = Foo

thm Spec_xexp
  Interpreter(Xexp,x,y) = Exp(x,y)

rem 
  \para \bf  Exercise.  \end \header* fun/0 Xpred 'Tex_f0_xpr_xpred' \end Find a 
  well-formed p.r. index of the predecessor function \ft x-1 \end, i.e. find the 
  number \ft Xpred \end such that 
  \eq* 
    Prf(1,Xpred)
  \end
  \eq* 
    Interpreter(Xpred,x) = x-1
  \end

fun/0 Xpred 'Tex_f0_xpr_xpred'
  Xpred = Foo

thm Spec_xpred
  Interpreter(Xpred,x) = x-1

rem 
  \para \bf  Exercise. \it  (1 point)  \end  \end 
  \header* fun/0 Xminus 'Tex_f0_xpr_xminus' \end Find a well-formed p.r. index 
  of the modified subtraction function \ft x-y \end, i.e. find the number 
  \ft Xminus \end such that 
  \eq* 
    Prf(2,Xminus)
  \end
  \eq* 
    Interpreter(Xminus,x,y) = x-y
  \end

fun/0 Xminus 'Tex_f0_xpr_xminus'
  Xminus = Foo

thm Spec_xminus
  Interpreter(Xminus,x,y) = x-y

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc fun Test_fun 
  Test_fun(x) = Foo

loc fun/2 Itfa 
  Itfa(0,a) = a
  Itfa(n+1,a) = Itfa(n,(n,Test_fun(n)),a)

loc fun Itf 
  Itf(n) = Itfa(n,0)

loc pred Test_pred 
  Test_pred(x) <-> Poo

loc fun/2 Itpa 
  Itpa(0,a) = a
  Itpa(n+1,a) = Itpa(n,n,a) <- Test_pred(n)
  Itpa(n+1,a) = Itpa(n,a) <- ~Test_pred(n)

loc fun Itp 
  Itp(n) = Itpa(n,0)

